/**
 * ŏ̒:: gDC[
 * |Wg:: $Id: CountPSListener.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 쌠:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * CZX:: CPL(Common Public Licence)
 */

#ifndef _TOPS_COUNT_PS_LISTENER_HPP_
#define _TOPS_COUNT_PS_LISTENER_HPP_

#include "tops/PSListener.hpp"

#include <boost/shared_ptr.hpp>

namespace tops {

	/**
	 * v_NVVXeɔCxgJEg郊XiłB
	 *
	 * @author gDC[
	 */
	class CountPSListener : public PSListener {
	private:
		int countOfAddedWMElement_;
		int countOfAddedProductionRule_;
		int countOfAddedAttribute_;

	public:
		/**
		 * Xi\z܂B
		 */
		CountPSListener() :
		countOfAddedWMElement_(0), countOfAddedProductionRule_(0), countOfAddedAttribute_(0) {
		}

	public:
		int sizeOfAddedWMElement() const {
			return countOfAddedWMElement_;
		}

		int sizeOfAddedProductionRule() const {
			return countOfAddedProductionRule_;
		}

		int sizeOfAddedAttribute() const {
			return countOfAddedAttribute_;
		}

	public:
		/**
		 * [LOvfǉꂽƂɌĂяo܂B
		 */
		void added(ProductionSystem& system, WMElement& element) {
			++countOfAddedWMElement_;
		}

		/**
		 * v_NV[ǉꂽƂɌĂяo܂B
		 */
		void added(ProductionSystem& system, ProductionRule& productionRule) {
			++countOfAddedProductionRule_;
		}

		/**
		 * ǉꂽƂɌĂяo܂B
		 */
		void added(ProductionSystem& system,
		           WMElement& element, const std::string& name, const ConstantPtr& constant) {
			++countOfAddedAttribute_;
		}
	};

	typedef boost::shared_ptr<CountPSListener> CountPSListenerPtr;

}  // namespace tops

#endif
