/**
 * ŏ̒:: gDC[
 * |Wg:: $Id: Unificator.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 쌠:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * CZX:: CPL(Common Public Licence)
 */

#ifndef _TOPS_UNIFICATOR_HPP_
#define _TOPS_UNIFICATOR_HPP_

#include "tops/UnificatedElements.hpp"
#include "tops/value/Variables.hpp"

#include <stack>

#include <boost/shared_array.hpp>
#include <boost/shared_ptr.hpp>

namespace tops {

	class ConditionPart;
	class UnificationState;
	typedef boost::shared_ptr<UnificationState> UnificationStatePtr;
	class UnificatorSub;
	class WorkingMemory;

	class Unificator;
	typedef boost::shared_ptr<Unificator> UnificatorPtr;

	/**
	 * IɒPꉻsPꉻqłB
	 *
	 * @author gDC[
	 */
	class Unificator {
	private:
		typedef boost::shared_ptr<UnificatorSub> UnificatorSubPtr;
		typedef boost::shared_array<UnificatorSubPtr> UnificatorSubArray;

	private:
		/**
		 * PꉻΏۂƂȂ郏[LOłB
		 */
		const WorkingMemory& m_workingMemory;

		/**
		 * PꉻΏۂƂȂłB
		 */
		ConditionPart& m_lhs;

		/**
		 * PꉻςݗvfłB
		 */
		UnificatedElements m_sources;

		/**
		 * PꉻɎgpϐ\łB
		 */
		Variables& m_variables;

		/**
		 * PꉻɎgpPꉻqiTujQłB
		 */
		std::stack<UnificatorSubPtr> m_unificators;

	public:
		/**
		 * Pꉻq\z܂B
		 *
		 * @param workingMemory PꉻΏۂƂȂ郏[LOw肵܂B
		 * @param lhs PꉻΏۂƂȂw肵܂B
		 * @param variables PꉻɎgp[\w肵܂B
		 */
		Unificator(const WorkingMemory& workingMemory, ConditionPart& lhs, Variables& variables);

	public:
		/**
		 * Pꉻs܂B
		 *
		 * @param result Pꉻɐꍇ͒PꉻԂAsꍇNULLԂ܂B
		 */
		UnificationStatePtr unificate();
	};

}  // namespace tops

#endif
